=== debian/changelog ===
pakcs (1.14.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop all patches recently cherry-picked from upstream. They are included
      in this upstream release.
  * debian/control:
    + Update versioned B-Ds for curry-libs-source (>= 1.0.3-1~) and
      curry-tools-source (>= 1.0.3+dfsg1-1~).
  * debian/pakcs.install:
    + The cpns/ and www/ code has been moved to curry-tools.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 24 Feb 2017 12:44:15 +0100
