=== debian/changelog ===
pakcs (1.14.4-2) unstable; urgency=medium

  * debian/patches:
    + Add 0001-Regression-test-for-CHR-library-removed-since-it-is-.patch
      from upstream. (Closes: #880797).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 07 Nov 2017 14:07:07 +0100

pakcs (1.14.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.1.1. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 03 Nov 2017 10:31:46 +0100

pakcs (1.14.3-1) unstable; urgency=medium

  * New upstream release. (Closes: #871194).
  * debian/watch:
    + Update to new tarball naming scheme in recent GitLab versions.
  * debian/control:
    + Bump Standards-Version: to 4.1.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 15 Sep 2017 14:42:27 +0200
